#ifndef GR_SECURITY_H
#define GR_SECURITY_H
#include <linux/fs.h>
#include <linux/binfmts.h>

extern void gr_del_task_from_ip_table(struct task_struct *p);

extern int gr_handle_follow_link(const struct inode *parent,
				 const struct inode *inode,
				 const struct dentry *dentry,
				 const struct vfsmount *mnt);
extern int gr_handle_fifo(const struct dentry *dentry,
			  const struct vfsmount *mnt,
			  const struct dentry *dir, const int flag,
			  const int acc_mode);
extern int gr_handle_hardlink(const struct dentry *dentry,
			      const struct vfsmount *mnt,
			      struct inode *inode,
			      const int mode, const char *to);

#ifdef CONFIG_SYSVIPC
extern void gr_shm_exit(struct task_struct *task);
#else
static inline void gr_shm_exit(struct task_struct *task)
{
	return;
}
#endif

#ifdef CONFIG_GRKERNSEC
extern int grsec_enable_shm;
#endif

#endif
